#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <stdarg.h>

#include <windows.h>

typedef struct {
	int code;
	char* maker;
} _makerids;

typedef struct {
	int splst;
	int fastrom, save;
	int hirom;
} _gameinfo;

typedef struct {
	char code[3];
	char* maker;
} _gbnewmaker;

_gbnewmaker gb_newmakers[] = {
	{ "2K", "NEC Interchannel" },
	{ "2L", "TAM" },
	{ "5G", "Majesco Sales, Inc." },
	{ "4K", "Time Warner Interactive" },
	{ "4X", "GT Interactive" },
	{ "4S", "T*HQ" },
	{ "4Z", "Crave Entertainment, Inc." },
	{ "0H", "Starfish" },
	{ "2L", "TAM" },
	{ "0L", "Warashi Inc." }
};

_makerids gb_makers[] = {
	{ 0x01, "Nintendo" },
	{ 0x08, "Capcom" },
	{ 0x09, "Hot-B" },
	{ 0x0a, "Jaleco" },
	{ 0x0b, "Coconuts" },
	{ 0x0c, "Elite Systems" },
	{ 0x13, "Electronic Arts" },
	{ 0x18, "Hudson Soft" },
	{ 0x19, "ITC Entertainment" },
	{ 0x1a, "Yanoman" },
	{ 0x1f, "Virgin" },
	{ 0x25, "San-x" },
	{ 0x28, "Kotobuki Systems" },
	{ 0x29, "Seta" },
	{ 0x35, "Hector" },
	{ 0x38, "Capcom" },
	{ 0x39, "Banpresto" },
	{ 0x3c, "Entertainment Int'l" },
	{ 0x3e, "Gremlin" },
	{ 0x41, "UBI soft" },
	{ 0x47, "Spectrum Holobyte" },
	{ 0x49, "Irem" },
	{ 0x4d, "Malibu" },
	{ 0x4f, "U.S. Gold" },
	{ 0x50, "Absolute" },
	{ 0x51, "Acclaim" },
	{ 0x52, "Activision" },
	{ 0x53, "American Sammy" },
	{ 0x54, "Gametek" },
	{ 0x55, "Park Place" },
	{ 0x56, "Ljn" },
	{ 0x57, "Matchbox" },
	{ 0x5a, "Mindscape" },
	{ 0x5b, "Romstar" },
	{ 0x5c, "Naxat Soft" },
	{ 0x5d, "Tradewest" },
	{ 0x60, "Titus" },
	{ 0x61, "Virgin" },
	{ 0x67, "Ocean" },
	{ 0x69, "Electronic Arts" },
	{ 0x6e, "Elite System" },
	{ 0x6f, "Electro Brain" },
	{ 0x70, "Infogrames" },
	{ 0x71, "Interplay" },
	{ 0x72, "Broderbound" },
	{ 0x73, "Sculptured Software" },
	{ 0x75, "The Sales Curve" },
	{ 0x78, "T*HQ" },
	{ 0x79, "Accolade" },
	{ 0x7a, "Triffix Entertainment" },
	{ 0x7c, "Microprose" },
	{ 0x7f, "Kemco" },
	{ 0x80, "Misawa Entertainment" },
	{ 0x83, "Lozc" },
	{ 0x86, "Tokuma Shoten Intermedia" },
	{ 0x8b, "Bullet-Proof Software" },
	{ 0x8c, "Vic Tokai" },
	{ 0x8e, "Ape" },
	{ 0x8f, "I'max" },
	{ 0x91, "Chun Soft" },
	{ 0x92, "Video System" },
	{ 0x93, "Suburava" },
	{ 0x95, "Varie" },
	{ 0x96, "Yonezawa/s'pal" },
	{ 0x97, "Kaneko" },
	{ 0x99, "Arc" },
	{ 0x9a, "Nihon Bussan" },
	{ 0x9b, "Tecmo" },
	{ 0x9c, "Imagineer" },
	{ 0x9d, "Banpresto" },
	{ 0x9f, "Nova" },
	{ 0xa1, "Hori Electric" },
	{ 0xa2, "Bandai" },
	{ 0xa4, "Konami" },
	{ 0xa6, "Kawada" },
	{ 0xa7, "Takara" },
	{ 0xa9, "Technos Japan" },
	{ 0xaa, "Broderbound" },
	{ 0xac, "Toei Animation" },
	{ 0xad, "Toho" },
	{ 0xaf, "Namco" },
	{ 0xb0, "Acclaim" },
	{ 0xb1, "Ascii or Nexoft" },
	{ 0xb2, "Bandai" },
	{ 0xb4, "Enix" },
	{ 0xb6, "Hal" },
	{ 0xb7, "SNK" },
	{ 0xb9, "Pony Canyon" },
	{ 0xba, "Culture Brain or Genetic Fantasia" },
	{ 0xbb, "Sunsoft" },
	{ 0xbd, "Sony Imagesoft" },
	{ 0xbf, "Sammy" },
	{ 0xc0, "Taito" },
	{ 0xc2, "Kemco" },
	{ 0xc3, "Squaresoft" },
	{ 0xc4, "Tokuma Shoten Intermedia" },
	{ 0xc5, "Data East" },
	{ 0xc6, "Tonkin House" },
	{ 0xc8, "Koei" },
	{ 0xc9, "UFL" },
	{ 0xca, "Ultra" },
	{ 0xcb, "Vap" },
	{ 0xcc, "Use" },
	{ 0xcd, "Meldac" },
	{ 0xce, "Pony Canyon or FCI" },
	{ 0xcf, "Angel" },
	{ 0xd0, "Taito" },
	{ 0xd1, "Sofel" },
	{ 0xd2, "Quest" },
	{ 0xd3, "Sigma Enterprises" },
	{ 0xd4, "Ask Kodansha" },
	{ 0xd6, "Naxat Soft" },
	{ 0xd7, "Copy Systems" },
	{ 0xd9, "Banpresto" },
	{ 0xda, "Tomy" },
	{ 0xdb, "Ljn" },
	{ 0xdd, "NCS" },
	{ 0xde, "Human" },
	{ 0xdf, "Altron" },
	{ 0xe0, "Jaleco" },
	{ 0xe1, "Towachiki" },
	{ 0xe5, "Epoch" },
	{ 0xe7, "Athena" },
	{ 0xe8, "Asmik" },
	{ 0xe9, "Natsume" },
	{ 0xea, "King Records" },
	{ 0xeb, "Atlus" },
	{ 0xec, "Epic/Sony Records" },
	{ 0xee, "IGS" },
	{ 0xf0, "A Wave" },
	{ 0xf3, "Extreme Entertainment" },
	{ 0xff, "Ljn" }
};

_makerids snes_makers[] = {
	{  1 ,  "Nintendo" }, {   131,  "Lozc"},
	{  3 ,  "Imagineer-Zoom" }, {   132,  "Koei"},
	{  5 ,  "Zamuse" }, {   134,  "Tokuma Shoten Intermedia"},
	{  6 ,  "Falcom" }, {   136,  "DATAM-Polystar"},
	{  8 ,  "Capcom" }, {   139,  "Bullet-Proof Software"},
	{  9 ,  "HOT-B" }, {   140,  "Vic Tokai"},
	{  10,  "Jaleco" }, {   142,  "Character Soft"},
	{  11,  "Coconuts" }, {   143,  "I''Max"},
	{  12,  "Rage Software" }, {   144,  "Takara"},
	{  14,  "Technos" }, {   145,  "CHUN Soft"},
	{  15,  "Mebio Software" }, {   146,  "Video System Co., Ltd."},
	{  18,  "Gremlin Graphics" }, {   147,  "BEC"},
	{  19,  "Electronic Arts" }, {   149,  "Varie"},
	{  21,  "COBRA Team" }, {   151,  "Kaneco"},
	{  22,  "Human/Field" }, {   153,  "Pack in Video"},
	{  23,  "KOEI" }, {   154,  "Nichibutsu"},
	{  24,  "Hudson Soft" }, {   155,  "TECMO"},
	{  26,  "Yanoman" }, {   156,  "Imagineer Co."},
	{  28,  "Tecmo" }, {   160,  "Telenet"},
	{  30,  "Open System" }, {   164,  "Konami"},
	{  31,  "Virgin Games" }, {   165,  "K.Amusement Leasing Co."},
	{  32,  "KSS" }, {   167,  "Takara"},
	{  33,  "Sunsoft" }, {   169,  "Technos Jap."},
	{  34,  "POW" }, {   170,  "JVC"},
	{  35,  "Micro World" }, {   172,  "Toei Animation"},
	{  38,  "Enix" }, {   173,  "Toho"},
	{  39,  "Loriciel/Electro Brain" }, {   175,  "Namco Ltd."},
	{  40,  "Kemco" }, {   177,  "ASCII Co. Activison"},
	{  41,  "Seta Co.,Ltd." }, {   178,  "BanDai America"},
	{  45,  "Visit Co.,Ltd." }, {   180,  "Enix"},
	{  49,  "Carrozzeria" }, {   182,  "Halken"},
	{  50,  "Dynamic" }, {   186,  "Culture Brain"},
	{  51,  "Nintendo" }, {   187,  "Sunsoft"},
	{  52,  "Magifact" }, {   188,  "Toshiba EMI"},
	{  53,  "Hect" }, {   189,  "Sony Imagesoft"},
	{  60,  "Empire Software" }, {   191,  "Sammy"},
	{  61,  "Loriciel" }, {   192,  "Taito"},
	{  64,  "Seika Corp." }, {   194,  "Kemco"},
	{  65,  "UBI Soft" }, {   195,  "Square"},
	{  70,  "System 3" }, {   196,  "Tokuma Soft"},
	{  71,  "Spectrum Holobyte" }, {   197,  "Data East"},
	{  73,  "Irem" }, {   198,  "Tonkin House"},
	{  75,  "Raya Systems/Sculptured Software" }, {   200,  "KOEI"},
	{  76,  "Renovation Products" }, {   202,  "Konami USA"},
	{  77,  "Malibu Games/Black Pearl" }, {   203,  "NTVIC"},
	{  79,  "U.S. Gold" }, {   205,  "Meldac"},
	{  80,  "Absolute Entertainment" }, {   206,  "Pony Canyon"},
	{  81,  "Acclaim" }, {   207,  "Sotsu Agency/Sunrise"},
	{  82,  "Activision" }, {   208,  "Disco/Taito"},
	{  83,  "American Sammy" }, {   209,  "Sofel"},
	{  84,  "GameTek" }, {   210,  "Quest Corp."},
	{  85,  "Hi Tech Expressions" }, {   211,  "Sigma"},
	{  86,  "LJN Toys" }, {   214,  "Naxat"},
	{  90,  "Mindscape" }, {   216,  "Capcom Co., Ltd."},
	{  93,  "Tradewest" }, {   217,  "Banpresto"},
	{  95,  "American Softworks Corp." }, {   218,  "Tomy"},
	{  96,  "Titus" }, {   219,  "Acclaim"},
	{  97,  "Virgin Interactive Entertainment" }, {   221,  "NCS"},
	{  98,  "Maxis" }, {   222,  "Human Entertainment"},
	{ 103,  "Ocean" }, {   223,  "Altron"},
	{ 105,  "Electronic Arts" }, {   224,  "Jaleco"},
	{ 107,  "Laser Beam" }, {   226,  "Yutaka"},
	{ 110,  "Elite" }, {   228,  "T&ESoft"},
	{ 111,  "Electro Brain" }, {   229,  "EPOCH Co.,Ltd."},
	{ 112,  "Infogrames" }, {   231,  "Athena"},
	{ 113,  "Interplay" }, {   232,  "Asmik"},
	{ 114,  "LucasArts" }, {   233,  "Natsume"},
	{ 115,  "Parker Brothers" }, {   234,  "King Records"},
	{ 117,  "STORM" }, {   235,  "Atlus"},
	{ 120,  "THQ Software" }, {   236,  "Sony Music Entertainment"},
	{ 121,  "Accolade Inc." }, {   238,  "IGS"},
	{ 122,  "Triffix Entertainment" }, {   241,  "Motown Software"},
	{ 124,  "Microprose" }, {   242,  "Left Field Entertainment"},
	{ 127,  "Kemco" }, {   243,  "Beam Software"},
	{ 128,  "Misawa" }, {   244,  "Tec Magik"},
	{ 129,  "Teichio" }, {   249,  "Cybersoft"},
	{ 130,  "Namco Ltd." }, {   255,  "Hudson Soft"},
};

char* countries[] = {
	"Jap",
	"USA",
	"PAL",
	"Swe",
	"Fin",
	"Den",
	"Fra",
	"Hol",
	"Spa",
	"Ger",
	"Ita",
	"Chi",
	"Ind",
	"Kor", "", ""
};

HANDLE h, hi;

void cprintf(char* fmt, ...)
{
	va_list arglist;
	char msgbuf[1024];
	DWORD x;

	va_start(arglist, fmt);
	_vsnprintf(msgbuf, 1024, fmt, arglist);
	va_end(arglist);

	WriteFile(h, msgbuf, strlen(msgbuf), &x, NULL);
}

#define printf cprintf

#define VERSION "2.3 Win32"
#define DATE    "20/05/99"

//#define COL(x) SetConsoleTextAttribute(h, x)
#define COL(x) ;

#define BLUE (FOREGROUND_BLUE)
#define LIGHTBLUE (FOREGROUND_BLUE|FOREGROUND_INTENSITY)
#define WHITE (FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE|FOREGROUND_INTENSITY)
#define LIGHTGRAY (FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE)
#define LIGHTGREEN (FOREGROUND_GREEN|FOREGROUND_INTENSITY)
#define YELLOW (FOREGROUND_GREEN|FOREGROUND_RED|FOREGROUND_INTENSITY)
#define LIGHTMAGENTA (FOREGROUND_RED|FOREGROUND_BLUE|FOREGROUND_INTENSITY)
#define LIGHTCYAN (FOREGROUND_GREEN|FOREGROUND_BLUE|FOREGROUND_INTENSITY)

bool HandlePause(int pause, int count, int height)
{
	if(pause && (count % (height-1))==0) {
		printf("-- <space> more, <q> quit --");
		FlushConsoleInputBuffer(hi);
		INPUT_RECORD ir;
		for(;;) {
			DWORD r;
			WaitForSingleObject(hi, INFINITE);
			ReadConsoleInput(hi, &ir, 1, &r);
			if(ir.EventType == KEY_EVENT && (ir.Event.KeyEvent.uChar.AsciiChar == ' ' || ir.Event.KeyEvent.uChar.AsciiChar == 'q')) break;
		}
		printf("\r");
		if(ir.Event.KeyEvent.uChar.AsciiChar == 'q') return true; else return false;
	} return false;
}


void main(int argc, char* argv[])
{

	FILE* fDiz;

	// output file -> append mode :)
	fDiz = fopen("file_id.diz", "a");

	h = GetStdHandle(STD_OUTPUT_HANDLE);
	hi= GetStdHandle(STD_INPUT_HANDLE);

	bool pause; if(argc > 1 && !stricmp(argv[1], "/p")) pause = true; else pause = false;

	int height = 0;
	if(pause) { // get console height
		CONSOLE_SCREEN_BUFFER_INFO csbi;
		if(!GetConsoleScreenBufferInfo(h, &csbi)) pause = 0; else {
			height = csbi.dwSize.Y;
		}
	}

	// print banner
	COL(BLUE); printf("\n -"); COL(LIGHTBLUE); printf("-");
	COL(WHITE); printf("- Console Directory " VERSION " SNES/N64/GB - (c) " DATE " - Bartman/Abyss -");
	COL(LIGHTBLUE); printf("-"); COL(BLUE); printf("-"); COL(LIGHTGRAY); printf("\n\n");
	COL(BLUE); printf("\n -"); COL(LIGHTBLUE); printf("-");
	COL(WHITE); printf("- Updated by Stage/HiGH SOCIETY  25.05.1999 -");
	COL(LIGHTBLUE); printf("-"); COL(BLUE); printf("-"); COL(LIGHTGRAY); printf("\n\n");

	struct _finddata_t fileinfo;
	_gameinfo gameinfo;
	long findhandle = _findfirst("*.*", &fileinfo);
	int result = findhandle;
	int count = 0;
	char dummy[8];
	FILE* f;
	while(result != -1) {
		int ofset;
		// skip extensions .2, ..., .9
		if(strlen(fileinfo.name) > 2 &&
		   fileinfo.name[strlen(fileinfo.name)-2] == '.' && (
		   fileinfo.name[strlen(fileinfo.name)-1] >= '2' &&
		   fileinfo.name[strlen(fileinfo.name)-1] <= '9')) goto next;
		// skip 0-sized files
		if(fileinfo.size == 0) goto next;
		if(fileinfo.size%16384 == 512) ofset = 512; else
		if(fileinfo.size%16384 == 0)   ofset = 0; else goto next;
		f = fopen(fileinfo.name, "rb"); if(!f || (int)f == -1) goto next;
		fseek(f, 2, SEEK_SET); fread(dummy, 1, 1, f);
		gameinfo.splst = (dummy[0] == '\x40');
		if((ofset == 0 || ofset == 512) && (unsigned)fileinfo.size < (unsigned)4*1024*1024+ofset) { // gameboy
			fseek(f, 0x116, SEEK_SET); fread(dummy, 1, 4, f);
			if(dummy[0] == '\x11' && dummy[1] == '\x1f' && dummy[2] == '\x88' && dummy[3] == '\x89') ofset = 0x135;
		}
		if(ofset == 512) /* SMC format or SMC savegame */ {
			fseek(f, 8, SEEK_SET); fread(dummy, 1, 4, f);
			if(dummy[0] == '\xaa' && dummy[1] == '\xbb' && dummy[2] == '\x05' && dummy[3] == '\x00') gameinfo.save = 1; else gameinfo.save = 0;
		} else gameinfo.save = 0;
		if(gameinfo.save == 0 && strlen(fileinfo.name) > 4 &&
		   fileinfo.name[strlen(fileinfo.name)-4] == '.' && 
		   fileinfo.name[strlen(fileinfo.name)-3] == 's' && 
		   fileinfo.name[strlen(fileinfo.name)-2] == 'a' && 
		   fileinfo.name[strlen(fileinfo.name)-1] == 'v') { fclose(f); goto next; }
		if(ofset == 0) {
			fseek(f, 0, SEEK_SET); fread(dummy, 1, 4, f);
			if(dummy[0] == '\x37' && dummy[1] == '\x80') ofset = 0x20; // V64
			if(dummy[0] == '\x80' && dummy[1] == '\x37') ofset = 0x800020; // Z64
		}

		if(count == 0) {
			COL(WHITE);        printf("Filename    ");
			COL(LIGHTBLUE);    printf("Format ");
			COL(LIGHTGREEN);   printf("Size ");
			COL(YELLOW);       printf("Title                 ");
			COL(LIGHTMAGENTA); printf("Feats/ID   ");
			COL(LIGHTGREEN);   printf("ROM SRAM ");
			COL(LIGHTCYAN);    printf("Company Cntry");
			COL(LIGHTGRAY);    printf("\n-------------------------------------------------------------------------------\n");

			// to diz
			fprintf(fDiz, "\n\n---------------------------------------------------------------------------------\n");
			fprintf(fDiz, "|Filename    ");
			fprintf(fDiz, "Format ");
			fprintf(fDiz, "Size ");
			fprintf(fDiz, "Title                 ");
			fprintf(fDiz, "Feats/ID   ");
			fprintf(fDiz, "ROM SRAM ");
			fprintf(fDiz, "Company Cntry|");
			fprintf(fDiz, "\n|-------------------------------------------------------------------------------|\n");
			count += 4;
		}
		if(ofset == 0x135) /* gameboy */ {
			char title[17], maker[32];
			char rom[5], ram[5];
			char color, sgb, newmak[3] = "";
			fseek(f, 0x134, SEEK_SET); fread(title, 1, 16, f); title[16] = 0;
			fseek(f, 0x143, SEEK_SET); fread(&color, 1, 1, f); color &= 0x80;
			fseek(f, 0x144, SEEK_SET); fread(newmak, 1, 2, f);
			fseek(f, 0x146, SEEK_SET); fread(&sgb,   1, 1, f); if(sgb == 3) sgb=1; else sgb=0;
			fseek(f, 0x147, SEEK_SET); fread(dummy, 1, 5, f);

			if(title[15] & 0x80) title[15] = 0;

			// dummy[4] (maker) = $33 fr color.....
			// dummy[0] = type (mbc1...)
			switch(dummy[1]) { // rom size
				case 0: strcpy(rom, "256K"); break;
				case 1: strcpy(rom, "512K"); break;
				case 2: strcpy(rom, "  1M"); break;
				case 3: strcpy(rom, "  2M"); break;
				case 4: strcpy(rom, "  4M"); break;
				case 5: strcpy(rom, "  8M"); break;
				case 6: strcpy(rom, " 16M"); break;
			}
			switch(dummy[2]) { // ram size
				case 0: strcpy(ram, "  --"); break;
				case 1: strcpy(ram, " 16K"); break;
				case 2: strcpy(ram, " 64K"); break;
				case 3: strcpy(ram, "256K"); break;
			}
			if(dummy[4] == 0x33) {
				_snprintf(maker, 32, "$%c%c         %s", newmak[0], newmak[1], dummy[3]==0?"J":"");
				for(int i = 0; i < sizeof(gb_newmakers)/sizeof(gb_newmakers[0]); i++) {
					if(!stricmp(newmak, gb_newmakers[i].code)) {
						if(dummy[3] != 0) _snprintf(maker, 32, "%-13.13s", gb_newmakers[i].maker);
						             else _snprintf(maker, 32, "%-11.11s J", gb_newmakers[i].maker);
						break;
					}
				}
				int newmaker;
				sscanf(newmak, "%02X", &newmaker);
				for(    i = 0; i < sizeof(gb_makers)/sizeof(gb_makers[0]); i++) {
					if(newmaker == gb_makers[i].code) {
						if(dummy[3] != 0) _snprintf(maker, 32, "%-13.13s", gb_makers[i].maker);
						             else _snprintf(maker, 32, "%-11.11s J", gb_makers[i].maker);
						break;
					}
				}
			} else _snprintf(maker, 32, "$%02x         %s", *(unsigned char*)&dummy[4], dummy[3]==0?"J":"");
			for(int i = 0; i < sizeof(gb_makers)/sizeof(gb_makers[0]); i++) {
				if(*(unsigned char*)&dummy[4] == gb_makers[i].code) {
					if(dummy[3] != 0) _snprintf(maker, 32, "%-13.13s", gb_newmakers[i].maker);
						         else _snprintf(maker, 32, "%-11.11s J", gb_newmakers[i].maker);
					break;
				}
			}
			COL(WHITE);        printf("%-13.13s ", fileinfo.name);
			COL(LIGHTBLUE);    printf("%c%cGB ", color?'C':' ', sgb?'S':' ');
			COL(LIGHTGREEN);   printf("%3d%c ", fileinfo.size>=128000?fileinfo.size/128000:fileinfo.size/128, fileinfo.size>=128000?'M':'K');
			COL(YELLOW);       printf("%-21s ", title);
			COL(LIGHTMAGENTA); printf("Gameboy   ");
			COL(LIGHTGREEN);   printf("%s %s ", rom, ram);
			COL(LIGHTCYAN);    printf("%s", maker);
			COL(LIGHTGRAY);    printf("\n"); count++;
			
			// to diz...
			fprintf(fDiz, "|%-13.13s ", fileinfo.name);
			fprintf(fDiz, "%c%cGB ", color?'C':' ', sgb?'S':' ');
			fprintf(fDiz, "%3d%c ", fileinfo.size>=128000?fileinfo.size/128000:fileinfo.size/128, fileinfo.size>=128000?'M':'K');
			fprintf(fDiz, "%-21s ", title);
			fprintf(fDiz, "Gameboy   ");
			fprintf(fDiz, "%s %s ", rom, ram);
			fprintf(fDiz, "%s|", maker);
			fprintf(fDiz, "\n"); count++;

			if(HandlePause(pause, count, height)) { fclose(f); goto quit; }
		} else if(gameinfo.save) {
			COL(WHITE);        printf("%-13.13s  ", fileinfo.name);
			COL(LIGHTBLUE);    printf("SAV ");
			COL(LIGHTGREEN);   printf("%3d%c                      ", fileinfo.size>=128000?fileinfo.size/128000:fileinfo.size/128, fileinfo.size>=128000?'M':'K');
			COL(LIGHTMAGENTA); printf("SNES Save            ");
			COL(LIGHTCYAN);    printf("Unknown");
			COL(LIGHTGRAY);    printf("\n"); count++;

			// to diz...
			fprintf(fDiz, "|%-13.13s  ", fileinfo.name);
			fprintf(fDiz, "SAV ");
			fprintf(fDiz, "%3d%c                      ", fileinfo.size>=128000?fileinfo.size/128000:fileinfo.size/128, fileinfo.size>=128000?'M':'K');
			fprintf(fDiz, "SNES Save            ");
			fprintf(fDiz, "Unknown|");
			fprintf(fDiz, "\n"); count++;

			if(HandlePause(pause, count, height)) { fclose(f); goto quit; }
		} else if(ofset == 0 || ofset == 512) /* SNES */ {
			char title[22], type[16], roms[5], rams[5], maker[32];
			// hi-rom check
			if(fileinfo.size > 0x18000) {
				unsigned char testhi, testhi2;
				fseek(f, 0x7fd7 + ofset, SEEK_SET); fread(&testhi, 1, 1, f);
				fseek(f, 0x7fd7 + ofset + 0x8000, SEEK_SET); fread(&testhi2, 1, 1, f);
				if((!(testhi >= 1 && testhi <= 12)) && (testhi2 >= 1 && testhi2 <= 12))
					ofset += 0x8000;
			}
			// title
			fseek(f, 0x7fc0 + ofset, SEEK_SET); title[0] = 0; fread(title, 1, 21, f); title[21] = 0;
			for(int i = 0; i < 22; i++) if((title[i] >= 7 && title[i] <= 10) || title[i] == 13) title[i] = '.';
			// flags
			unsigned char typex, romtype, romsize, ramsize, makercode, country;
			fseek(f, 0x7fd5 + ofset, SEEK_SET);
			fread(&romtype, 1, 1, f);
			if((romtype >> 4) == 3) gameinfo.fastrom = 1; else gameinfo.fastrom = 0;
			if((romtype & 0xf) > 0) gameinfo.hirom = 1; else gameinfo.hirom = 0;
			fread(&typex, 1, 1, f);
			switch(typex) {
				case   0: strcpy(type, ""); break;
				case   1: strcpy(type, "RAM"); break;
				case   2: strcpy(type, "SRAM"); break;
				case   3: strcpy(type, "DSP1"); break;
				case   4: strcpy(type, "RAM+DSP1"); break;
				case   5: strcpy(type, "SRAM+DSP1"); break;
				case  19: strcpy(type, "FX"); break;
				case  21: strcpy(type, "SRAM+FX"); break;
				case 227: strcpy(type, "RAM+GB"); break;
				case 246: strcpy(type, "DSP2"); break;
				default:  strcpy(type, "????");
			}
			fread(&romsize, 1, 1, f);
			switch(romsize) {
				case   8: strcpy(roms, "  2M"); break;
				case   9: strcpy(roms, "  4M"); break;
				case  10: strcpy(roms, "  8M"); break;
				case  11: strcpy(roms, " 16M"); break;
				case  12: strcpy(roms, " 32M"); break;
				default:  strcpy(roms, "????"); break;
			}
			fread(&ramsize, 1, 1, f);
			switch(ramsize) {
				case 0: if(typex == 2 || typex == 5 || typex == 21) strcpy(rams, "None"); else strcpy(rams, "    "); break;
				case 1: strcpy(rams, " 16K"); break;
				case 2: strcpy(rams, " 32K"); break;
				case 3: strcpy(rams, " 64K"); break;
			}
			fread(&country, 1, 1, f);
			fread(&makercode, 1, 1, f);
			_snprintf(maker, 32, "$%02x", makercode);
			for(int j = 0; j < sizeof(snes_makers)/sizeof(snes_makers[0]); j++) {
				if(makercode == snes_makers[j].code) {
					strncpy(maker, snes_makers[j].maker, 32); break;
				}
			}
			COL(WHITE);        printf("%-13.13s", fileinfo.name);
			COL(LIGHTBLUE);    printf("%c%c%s%c", gameinfo.splst?'>':' ', gameinfo.fastrom?'=':' ', ofset==0?"MGD":"SMC", gameinfo.hirom?'^':' ');
			COL(LIGHTGREEN);   printf("%3d%c ", fileinfo.size>=128000?(fileinfo.size-(ofset&0x200))/128000:(fileinfo.size-(ofset&0x200))/128, fileinfo.size>=128000?'M':'K');
			COL(YELLOW);       printf("%-21s ", title);
			COL(LIGHTMAGENTA); printf("%-9s ", type);
			COL(LIGHTGREEN);   printf("%s %s ", roms, rams);
			COL(LIGHTCYAN);    printf("%-9.9s %-3s", maker, countries[country & 0xf]);
			COL(LIGHTGRAY);    printf("\n"); count++;

			// to diz...
			fprintf(fDiz, "|%-13.13s", fileinfo.name);
			fprintf(fDiz, "%c%c%s%c", gameinfo.splst?'>':' ', gameinfo.fastrom?'=':' ', ofset==0?"MGD":"SMC", gameinfo.hirom?'^':' ');
			fprintf(fDiz, "%3d%c ", fileinfo.size>=128000?(fileinfo.size-(ofset&0x200))/128000:(fileinfo.size-(ofset&0x200))/128, fileinfo.size>=128000?'M':'K');
			fprintf(fDiz, "%-21s ", title);
			fprintf(fDiz, "%-9s ", type);
			fprintf(fDiz, "%s %s ", roms, rams);
			fprintf(fDiz, "%-9.9s %-3s|", maker, countries[country & 0xf]);
			fprintf(fDiz, "\n"); count++;
	
			if(HandlePause(pause, count, height)) { fclose(f); goto quit; }
		} else if(ofset == 0x20 || ofset == 0x800020) /* V64/Z64 */ {
			char title[21], mak[3], id[3], coun[3], country[4], maker[16];
			fseek(f, 0x20, SEEK_SET); fread(title, 1, 20, f); title[20] = '\0';
			fseek(f, 0x3a, SEEK_SET); fread(mak, 1, 2, f); mak[2] = '\0';
			fread(id, 1, 2, f); id[2] = '\0';
			fread(coun, 1, 2, f); coun[2] = '\0';
			if(ofset == 0x20) {
				for(int i = 0; i < 20; i += 2) {
					char temp = title[i]; title[i] = title[i+1]; title[i+1] = temp;
				}
				char temp = mak[0]; mak[0] = mak[1]; mak[1] = temp;
				     temp = id[0]; id[0] = id[1]; id[1] = temp;
				     temp = coun[0]; coun[0] = coun[1]; coun[1] = temp;
			}
			switch((mak[0] << 8) | mak[1]) {
				case '\0N': strcpy(maker, "Nintendo"); break;
				   default: sprintf(maker, "Unknown %c", mak[1]); break;
			}
			switch(coun[0]) {
				case 'J': strcpy(country, "Jap"); break;
				case 'E': strcpy(country, "USA"); break;
				case 'P': strcpy(country, "PAL"); break;
				case 'D': strcpy(country, "Ger"); break;
				 default: sprintf(country, "??%c", coun[0]); break;
			}
			
			COL(WHITE);        printf("%-13.13s", fileinfo.name);
			COL(LIGHTBLUE);    printf("  %c64 ", ofset==0x20?'V':'Z');
			COL(LIGHTGREEN);   printf("%3dM ", fileinfo.size/131072);
			COL(YELLOW);       printf("%-21s ", title);
			COL(LIGHTMAGENTA); printf("'%-2.2s'      ", id);
			COL(LIGHTGREEN);   printf("          ");
			COL(LIGHTCYAN);    printf("%-9.9s %-3s", maker, country);
			COL(LIGHTGRAY);    printf("\n"); count++;
	
			// to diz			
			fprintf(fDiz, "|%-13.13s", fileinfo.name);
			fprintf(fDiz, "  %c64 ", ofset==0x20?'V':'Z');
			fprintf(fDiz, "%3dM ", fileinfo.size/131072);
			fprintf(fDiz, "%-21s ", title);
			fprintf(fDiz, "'%-2.2s'      ", id);
			fprintf(fDiz, "          ");
			fprintf(fDiz, "%-9.9s %-3s|", maker, country);
			fprintf(fDiz, "\n"); count++;

			if(HandlePause(pause, count, height)) { fclose(f); goto quit; }
		}
next:	result = _findnext(findhandle, &fileinfo);
	}
			if(HandlePause(pause, count, height)) { fclose(f); goto quit; }
quit:
	if(findhandle != -1) _findclose(findhandle);

	// close the output file...

	fprintf(fDiz, "-----------------------------| www.high-society.at |-----------------------------");
	fclose(fDiz);
}
